#include <bits/stdc++.h>
#define ll long long
#define pb push_back
using namespace std;
int X, K, N;
ll P[200005], PS[200006], PSPS[200005];
bool flag = false;
int main(){
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cin >> N >> K >> X;
  for(int i = 1; i <= N; i++)
  {
    cin >> P[i];
    if(P[i] < 0)flag = true;
  }
  for(int i = 1; i <= N; i++)
    {
      PS[i] = PS[i - 1] + P[i];
      PSPS[i] = PSPS[i - 1] + PS[i];
//      cout << PS[i] << ' ';
    }
  if(N <= 20)
  {
    for(int i = 1; i <= N - K + 1; i++)
    {
      ll sol = P[i];
      ll MAX = -2e18;
      for(int j = i + 1; j <= i + K - 1; j++)
      {

      }
    }
  }
  if(!flag)
  {

//    cout << '\n';
    for(int i = 1; i <= N; i++)cout << PSPS[i] << ' ';
//    cout << '\n';
    for(int i = 1; i <= N - K + 1; i++)
    {
      int j = i + K - 1;
//      cout << '\n';
//      cout << i << ' ' << j << '\n';
//      cout << (PS[j] - PS[i - 1]) << '\n';
//      cout << PSPS[j] - PSPS[i - 1] << '\n';
      cout << (PS[j] - PS[i - 1]) * X - X << ' ';
//      cout << '\n';
    }
    return 0;
  }
  if(X == 1)
  {
    for(int i = 1; i <= N - K + 1; i++)
    {
      int j = i + K - 1;
      cout << PS[j] - PS[i - 1] << ' ';
    }
  }
  for(int i = 1; i <= N - K + 1; i++)
  {

  }

  return 0;
}